=== thirdparty/sentry-native/tests/requirements.txt ===
black==23.3.0
pytest==7.4.0
pytest-httpserver==1.0.8
msgpack==1.0.5
